%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Purpose: Run trained PCG classifier and obtain classifier outputs
% Inputs:
% 1. header
% 2. recordings
% 3. trained model
%
% Outputs:
% 1. score
% 2. label
% 3. classes
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [score, label, classes] = team_testing_code(header, recordings, loaded_model)

classes_murmur=loaded_model.classes_murmur;
classes_outcome=loaded_model.classes_outcome;

% features=get_features(header,recordings);

% [label_tmp_murmur,score_murmur]=loaded_model.model_murmur.predict(features);
% label_murmur=zeros(1,length(classes_murmur));
% label_murmur(strmatch(label_tmp_murmur,classes_murmur))=1;
% 
% [label_tmp_outcome,score_outcome]=loaded_model.model_outcome.predict(features);
% label_outcome=zeros(1,length(classes_outcome));
% label_outcome(strmatch(label_tmp_outcome,classes_outcome))=1;

% classes=[classes_murmur classes_outcome];
% score=[score_murmur score_outcome];
% 
% label=[label_murmur label_outcome];



Seg_dur=30; % 9 seconds as a unit
Fs =4000;
signalLength = Seg_dur*Fs;
% labels=[];
scores=[];
% for i=1:length(recordings)

temp=str2num(header{1});

Fs_current =temp(end);% added

current_recordings=recordings;
tempfolder=fullfile(pwd, 'temp');
if not(isfolder(tempfolder))
    mkdir(tempfolder);
end
delete(fullfile(tempfolder, '\*'));
for i=1:length(current_recordings)
    
    sig=current_recordings{1, i};
    
    if Fs_current==2000;
        sig=resample(sig, 2,1);
    end
    if length(sig)>=signalLength
        
        sig=sig(1:signalLength);
    else
        sig=[sig;zeros(signalLength-length(sig),1)]; % padding if shorter than predefiend
    end
    % [S,F,T] = stft(sig,Fs,'FrequencyRange','onesided');
    %         [S,F,T] = melSpectrogram(sig,Fs,'NumBands',13);
    [S,F,T] = melSpectrogram(sig,Fs, ...
        'NumBands',64, ...
        'FrequencyRange',[25,2000]);
    smag = mag2db(abs(S)); % Convert to dB
    % caxisLims = max(smag(:)) + [-100 0]; % Color axis limits
    %
    
    %         smag(smag<(max(smag(:))-100))=min(smag(:));
    test=smag;
    %         test=[smag(:, 1:224);smag(:, 225:224*2);smag(:, 449:224*3);smag(:, 673:896);];
    test(test==-inf)=nan;
    im = ind2rgb(im2uint8(rescale(test)),jet);
   
    imageRoot = tempfolder;
    imwrite(imresize(im,[227 227]),fullfile(imageRoot,[num2str(i),'.png']),'png');
end
%%
allImages = imageDatastore(fullfile(tempfolder,'*.png'));
allImages.ReadFcn = @readFunctionTrain;

[~,scores_murmur] = classify(loaded_model.model_murmur, allImages);

score_murmur=mean(scores_murmur,1);

[highscore,ind]=max(score_murmur);
label_tmp=classes_murmur{ind};

label_murmur=zeros(1,length(classes_murmur));
label_murmur(strmatch(label_tmp,classes_murmur))=1;


[~,scores_outcome] = classify(loaded_model.model_outcome, allImages);

score_outcome=mean(scores_outcome,1);

[highscore,ind]=max(score_outcome);
label_tmp=classes_outcome{ind};

label_outcome=zeros(1,length(classes_outcome));
label_outcome(strmatch(label_tmp,classes_outcome))=1;


classes=[classes_murmur classes_outcome];
score=[score_murmur score_outcome];

label=[label_murmur label_outcome];
end




function I2 = readFunctionTrain(filename)
% resize the ekg data
I = imread(filename);

I2 = imresize(I, [227 227]);
end